import { SetStateAction, WritableAtom } from 'jotai';
import type { CommonState } from './atomWithValidate';
type inferGeneric<Type> = Type extends AtomWithValidation<infer X> ? X : never;
export type Validator<Keys extends symbol | string | number, Vals> = (values: Record<Keys, Vals>) => void | Promise<void>;
export type ValidatorState = {
    isValid: undefined | boolean;
    error: null | Error | unknown;
    isValidating: undefined | boolean;
};
type AtomWithValidation<Value> = WritableAtom<CommonState<Value>, SetStateAction<Value>>;
type State<Values extends Record<string, unknown>> = {
    values: Values;
} & ValidatorState;
export declare const validateAtoms: <AtomGroup extends Record<string, AtomWithValidation<any>>, Keys extends keyof AtomGroup, Vals extends AtomGroup[Keys]>(labeledAtoms: AtomGroup, validator: Validator<Keys, inferGeneric<Vals>>) => import("jotai").Atom<State<Record<Keys, inferGeneric<Vals>>>>;
export {};
